Scriptname SLApproachMainScript extends Quest Conditional

SLAppPCSexQuestScript Property SLAppPCSex Auto

Faction Property slapp_AquaintedFaction Auto
Faction Property slapp_DislikeFaction Auto
Faction Property slapp_RapeFailFaction Auto
Faction Property slapp_ReconciliationFaction Auto


Faction Property BaboAggressiveBoyFriend Auto
Faction Property BaboDialogueFaction Auto
Faction Property BaboViceGuardCaptainFaction Auto
Faction Property BaboWasHireling Auto
Faction Property BaboPotentialHireling Auto
Faction Property BaboCurrentHireling Auto

ObjectReference Property BaboChestWhiterunRef Auto
Keyword Property SLHHScriptEventKeyword Auto

Actor Property PlayerRef Auto
Spell Property ApproachCloak Auto
Spell Property SLApproachCloakAbility Auto
int Property SLApproachTimelimit = 30 Auto
int Property cloakFrequency = 13 Auto
float Property baseChanceMultiplier = 0.7 Auto
int Property totalAwarnessRange = 256 Auto ; no longer used

float Property ProstitutionAcceptChance = 0.0 Auto Conditional

bool Property enableSLHHFlag = false Auto Conditional
bool Property enableBDFlag = false Auto Conditional

bool Property debugLogFlag = false Auto
bool Property enablePromiseFlag = false Auto 
bool Property enableRapeFlag = true Auto
bool Property enableForceThirdPersonHug = true Auto
bool Property enableRelationChangeFlag = false Auto ; no longer used
bool Property enableElderRaceFlag = false Auto
bool Property enableFollowerFlag = false Auto
bool Property enableHirelingFlag = false Auto
bool Property enableGuardFlag = false Auto
bool Property enableChildFlag = false Auto
bool Property enableThalmorFlag = false Auto
bool Property enablePetsFlag = false Auto ; Temporarily locked
bool Property enablePlayerHorseFlag = false Auto ; Temporarily locked

GlobalVariable Property SLAStandardLevelMaximumNPCGlobal Auto
GlobalVariable Property SLAStandardLevelMinimumNPCGlobal Auto

bool property SLALowerLevelNPC = false Auto
bool property SLAHigherLevelNPC = false Auto
bool property SLAStandardLevelNPC = false Auto

int property SLAHouseVisitChance = 5 Auto

int property SLARelationshipChance = 40 Auto
int property SLAAquaintanceChance = 80 Auto
int property SLADislikeChance = 50 Auto

int property SLADeviationLevel = 5 Auto

int property SLAPCAppearance = 50 Auto
int property SLAPCBreasts = 50 Auto
int property SLAPCButts = 50 Auto

bool Property SLANakedArmor = false Auto

bool Property SLAUniqueActor = false Auto

bool Property SLAProstitution = false Auto Conditional
bool Property SLAProstitutionFollow = false Auto Conditional

int Property SLAProstitutionpayway Auto Conditional; 0 means prepaid and 1 means postpaid

int Property lowestArousalPC = 0 Auto
int Property lowestArousalNPC = 10 Auto

int Property userAddingPointPc = -20 Auto;-150~100
int Property userAddingPointNpc = -10 Auto

int Property userAddingRapePointPc = 0 Auto
int Property userAddingRapePointNpc = 0 Auto

int Property userAddingHugPointPc = 0 Auto
int Property userAddingHugPointNpc = 0 Auto

int Property userAddingaskingnamePointPc = -20 Auto
int Property userAddingKissPointPc = -10 Auto
int Property userAddingKissPointNpc = -10 Auto

bool property hasfoundtheactor = false Auto
bool property isDuringCloakPulse = false Auto
int Property actorsEffectStarted = 0 Auto
int Property actorsEffectFinished = 0 Auto

bool Property isSkipUpdateMode = false Auto

slapp_util Property slappUtil Auto

int my_cloakRange = 192

int Property cloakRange
	int Function get()
		return my_cloakRange
	EndFunction
	Function set(int value)
		my_cloakRange = value
		ApproachCloak.SetNthEffectMagnitude(0, value as float)
	EndFunction
EndProperty

bool initilized = false

int registeredQuestsAmount
bool[] approachQuestsInitilizationArray
Quest[] approachQuests
string[] approachQuestNames
SLApproachBaseQuestScript[] approachQuestScripts

Event OnInit()
	Maintenance()
EndEvent

Function Maintenance()
	if (!initilized)
		initApproachQuestRegister()
	endif
	
	initilized = true
	PlayerRef.RemoveSpell(SLApproachCloakAbility)

	UnregisterForAllModEvents()
EndFunction

Function initApproachQuestRegister()
	registeredQuestsAmount = 0

	approachQuestsInitilizationArray = New bool[8]
	int counter = 8

	while counter
		counter -= 1
		approachQuestsInitilizationArray[counter] = false
	endwhile

	approachQuests = New Quest[8]
	approachQuestNames = new string[8]
	approachQuestScripts = new SLApproachBaseQuestScript[8]
EndFunction

bool Function StartInitOfQuestByIndex(int index)
	if (approachQuestsInitilizationArray[index])
		return false
	else
		slappUtil.log("START index = " + index + " appQuestInitArray => " + approachQuestsInitilizationArray[index])
		approachQuestsInitilizationArray[index] = true
		return true
	endif
EndFunction

Function EndtInitOfQuestByIndex(int index)
	if (index >= 0)
		slappUtil.log("END index = " + index + " appQuestInitArray => " + approachQuestsInitilizationArray[index])
		approachQuestsInitilizationArray[index] = false
	endif
EndFunction

Function clearQuestStatus()
	int idx = approachQuestsInitilizationArray.Length
	while (idx > 0)
		idx -= 1
		approachQuestsInitilizationArray[idx] = false
	endwhile
	
	int qidx = getregisteredAmount()
	while (qidx > 0)
		qidx -= 1
		approachQuestScripts[qidx].endApproachForce()
	endwhile
EndFunction

int Function RegisterQuest(Quest newQuest, SLApproachBaseQuestScript newQuestScript, string newQuestName)
	if(!initilized)
		return -1
	endif
	
	int indexCounter = registeredQuestsAmount - 1
	while (indexCounter >= 0)
		if (approachQuestNames[indexCounter] == newQuestName)
			approachQuests[indexCounter] = newQuest
			approachQuestScripts[indexCounter] = newQuestScript
			; debug.notification("Sexlab Approach: Approach named " + newQuestName + " is running.")
			return indexCounter
		endif
		indexCounter = indexCounter - 1
	endwhile
	
	if (registeredQuestsAmount < 8)
		int newIndex = registeredQuestsAmount
		registeredQuestsAmount = registeredQuestsAmount + 1
		
		approachQuests[newIndex] = newQuest
		approachQuestScripts[newIndex] = newQuestScript
		approachQuestNames[newIndex] = newQuestName
		debug.notification("Sexlab Approach: Approach named " + newQuestName + " registered.")

		if(!newQuest.isRunning())
			newQuest.Start()
			debug.notification("SexLab Approach: " + newQuestName + " - Quest Init")
		endif

		return newIndex
	endif
	
	debug.notification("Sexlab Approach: Quest registration failed due to exceeding max approach quest limit.")
	return -1
EndFunction

int Function getregisteredAmount()
	return registeredQuestsAmount
EndFunction

;quest Function getApproachQuest(int index)
;	if (index < registeredQuestsAmount && index >= 0)
;		return approachQuests[index]
;	endif
;	
;	debug.notification("Sexlab Approach: Quest retrival failed - invalid index " + index)
;	debug.trace("Sexlab Approach: Quest retrival failed - invalid index " + index)
;
;	return None
;EndFunction

SLApproachBaseQuestScript Function getApproachQuestScript(int index)
	if (index < registeredQuestsAmount && index >= 0)
		return approachQuestScripts[index]
	endif
	
	debug.notification("Sexlab Approach: Script retrival failed - invalid index " + index)
	debug.trace("Sexlab Approach: Script retrival failed - invalid index " + index)
	
	return None
EndFunction

string Function getApproachQuestName(int index)
	if (index < registeredQuestsAmount && index >= 0)
		return approachQuestNames[index]
	endif
	
	debug.notification("Sexlab Approach: Quest Name retrival failed - invalid index " + index)
	debug.trace("Sexlab Approach: Quest Name retrival failed - invalid index " + index)

	return None
EndFunction

Function addActorEffectStarted() ; When the Cloak Effect Starts.
	actorsEffectStarted += 1
EndFunction

Function addActorEffectFinished() ; When the Cloak Effect Finished.
	actorsEffectFinished += 1
EndFunction

Event OnCrosshairRefChange(ObjectReference ref)
	if ref
		if ref.GetBaseObject() as Door
			;ObjectReference linked_door = GetLinkedref(ref);it doesn't work this way.
			Key door_key = ref.GetKey()
			if door_key
				SLAppPCSex.DoorKeyexist = true
				if PlayerRef.GetItemCount(door_key) == 0
					SLAppPCSex.HasDoorKey = false
				else
					SLAppPCSex.HasDoorKey = true
				endif
			else
				SLAppPCSex.DoorKeyexist = false
			endif
		endif
	endif
EndEvent

Function Openthedoor(ObjectReference ref)
	Key door_key = ref.GetKey()
	if PlayerRef.GetItemCount(door_key) == 0
		Debug.messagebox("I don't have the key to unlock the door.")
	else
		ref.Activate(PlayerRef)
	endif
EndFunction

Function Lockthedoor(ObjectReference ref, bool lockdoor)
	Key door_key = ref.GetKey()
	if PlayerRef.GetItemCount(door_key) >= 1 && (lockdoor == true)
		ref.lock(true, true)
		debug.notification("I locked the door")
	elseif PlayerRef.GetItemCount(door_key) >= 1 && (lockdoor == false)
		ref.lock(false, true)
		debug.notification("I unlocked the door")
	else
		debug.notification("I don't have the key to lock the door.")
	endif
EndFunction
